﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GamePlayController : MonoBehaviour {
	public GameObject P1a, P2a, P1b, P2b, P1c, P2c;

	public float speed;
	private bool Play = false;

	public bool Lane01;
	public bool Lane02;
	public bool Lane03;

	int P1ChoiceNum;

	public bool P1Lane01 = false;
	public bool P1Lane02 = false;
	public bool P1Lane03 = false;

	int P2ChoiceNum;

	public bool P2Lane01 = false;
	public bool P2Lane02 = false;
	public bool P2Lane03 = false;

	//Game audio
	public AudioSource MainTheme;

	public GameObject LaneP1;
	public GameObject LaneP2;

	public GameObject P1Choice01;
	public GameObject P1Choice02;
	public GameObject P2Choice01;
	public GameObject P2Choice02;

	public Rigidbody CubeRig;
	public Rigidbody CubeRig2;
	public Transform CubeTrans;
	public Transform CubeTransOpp;

	public Rigidbody PyramidRig;
	public Rigidbody PyramidRig2;
	public Transform PyramidTrans;
	public Transform PyramidTransOpp;

	public Rigidbody SphereRig;
	public Rigidbody SphereRig2;
	public Transform SphereTrans;
	public Transform SphereTransOpp;

	//Trigger to set the play game state true
	public void Playing(){
		Play = true;
	}

	// Use this for initialization
	void Start () {
		speed = 1000f;

		MainTheme = GetComponent<AudioSource> ();

		P1a.SetActive (false);
		P1b.SetActive (true);
		P1c.SetActive (false);

		P2a.SetActive (false);
		P2b.SetActive (true);
		P2c.SetActive (false);
	}
	
	// Update is called once per frame
	void Update () {
		
		if (Play == true){
			MainTheme.Play ();
		}

		ChangeToLane1 ();
		ChangeToLane2 ();
		ChangeToLane3 ();

		P2ChangeToLane1 ();
		P2ChangeToLane2 ();
		P2ChangeToLane3 ();

		SpawnP1Cube();
		SpawnP1Sphere();
		SpawnP1Pyramid();

		SpawnP2Cube ();
		SpawnP2Sphere ();
		SpawnP2Pyramid ();
	}

	//CHANING LANES FOR PLAYER 1
	void ChangeToLane1()
	{
		if (P1Lane01 == false)
		{
			if (Input.GetKeyDown (KeyCode.Q))
			{
				LaneP1 = GameObject.Find ("PlayingField/Lane01");
				P1Choice01 = GameObject.Find ("PlayerSides/P1_side/L1Choice1");
				P1Choice02 = GameObject.Find ("PlayerSides/P1_side/L1Choice2");
				P1ChoiceNum = 0;
				P1Lane01 = true;
				P1Lane02 = false;
				P1Lane03 = false;

				P1a.SetActive (true);
				P1b.SetActive (false);
				P1c.SetActive (false);
			}
		}
	}

	void ChangeToLane2()
	{
		if (P1Lane02 == false)
		{
			if (Input.GetKeyDown (KeyCode.W))
			{
				LaneP1 = GameObject.Find ("PlayingField/Lane02");
				P1Choice01 = GameObject.Find ("PlayerSides/P1_side/L2Choice1");
				P1Choice02 = GameObject.Find ("PlayerSides/P1_side/L2Choice2");
				P1ChoiceNum = 0;
				P1Lane01 = false;
				P1Lane02 = true;
				P1Lane03 = false;

				P1a.SetActive (false);
				P1b.SetActive (true);
				P1c.SetActive (false);
			}
		}
	}

	void ChangeToLane3()
	{
		if (P1Lane03 == false)
		{
			if (Input.GetKeyDown (KeyCode.E))
			{
				LaneP1 = GameObject.Find ("PlayingField/Lane03");
				P1Choice01 = GameObject.Find ("PlayerSides/P1_side/L3Choice1");
				P1Choice02 = GameObject.Find ("PlayerSides/P1_side/L3Choice2");
				P1ChoiceNum = 0;
				P1Lane01 = false;
				P1Lane02 = false;
				P1Lane03 = true;

				P1a.SetActive (false);
				P1b.SetActive (false);
				P1c.SetActive (true);
			}
		}
	}

	//CHANING LANES FOR PLAYER 2
	void P2ChangeToLane1()
	{
		if (P2Lane01 == false)
		{
			if (Input.GetKeyDown (KeyCode.Keypad4))
			{
				LaneP2 = GameObject.Find ("PlayingField/Lane01");
				P2Choice01 = GameObject.Find ("PlayerSides/P2_side/L1Choice1_P2");
				P2Choice02 = GameObject.Find ("PlayerSides/P2_side/L1Choice2_P2");
				P2ChoiceNum = 0;
				P2Lane01 = true;
				P2Lane02 = false;
				P2Lane03 = false;

				P2a.SetActive (true);
				P2b.SetActive (false);
				P2c.SetActive (false);
			}
		}
	}

	void P2ChangeToLane2()
	{
		if (P2Lane02 == false)
		{
			if (Input.GetKeyDown (KeyCode.Keypad5))
			{
				LaneP2 = GameObject.Find ("PlayingField/Lane02");
				P2Choice01 = GameObject.Find ("PlayerSides/P2_side/L2Choice1_P2");
				P2Choice02 = GameObject.Find ("PlayerSides/P2_side/L2Choice2_P2");
				P2ChoiceNum = 0;
				P2Lane01 = false;
				P2Lane02 = true;
				P2Lane03 = false;

				P2a.SetActive (false);
				P2b.SetActive (true);
				P2c.SetActive (false);
			}
		}
	}

	void P2ChangeToLane3()
	{
		if (P2Lane03 == false)
		{
			if (Input.GetKeyDown (KeyCode.Keypad6))
			{
				LaneP2 = GameObject.Find ("PlayingField/Lane03");
				P2Choice01 = GameObject.Find ("PlayerSides/P2_side/L3Choice1_P2");
				P2Choice02 = GameObject.Find ("PlayerSides/P2_side/L3Choice2_P2");
				P2ChoiceNum = 0;
				P2Lane01 = false;
				P2Lane02 = false;
				P2Lane03 = true;

				P2a.SetActive (false);
				P2b.SetActive (false);
				P2c.SetActive (true);
			}
		}
	}

	//PLAYER 1 CONTROLS
	void SpawnP1Cube()
	{
		if (P1Lane01 == true || P1Lane02 == true || P1Lane03 == true)
		{
			if (P1ChoiceNum < 2)
			{
				if (Input.GetKeyDown (KeyCode.A))
				{
					P1ChoiceNum++;
					if (P1ChoiceNum == 1)
					{
						CubeTrans.position = P1Choice01.transform.position;
						CubeTrans.position = new Vector3 (LaneP1.transform.position.x, 2, CubeTrans.position.z);
					} else if (P1ChoiceNum == 2)
					{
						CubeTrans.position = P1Choice02.transform.position;
						CubeTrans.position = new Vector3 (LaneP1.transform.position.x, 2, CubeTrans.position.z);
					}
					//CubeTrans.position = new Vector3 (LaneP1.transform.position.x, 2, CubeTrans.position.z);
					Rigidbody CubeInstance;
					CubeInstance = Instantiate (CubeRig, CubeTrans.position, CubeTrans.rotation) as Rigidbody;
					//CubeInstance.AddForce (CubeTrans.up * speed);

					CubeInstance.gameObject.tag = "P1Cube";
					//Debug.Log (CubeInstance.velocity);
				}

			}
		}
	}

	void SpawnP1Sphere()
	{
		if (P1Lane01 == true || P1Lane02 == true || P1Lane03 == true)
		{
			if (P1ChoiceNum < 2)
			{
				if (Input.GetKeyDown (KeyCode.S))
				{
					P1ChoiceNum++;
					if (P1ChoiceNum == 1)
					{
						SphereTrans.position = P1Choice01.transform.position;
						SphereTrans.position = new Vector3 (LaneP1.transform.position.x, 2, SphereTrans.position.z);
					} else if (P1ChoiceNum == 2)
					{
						SphereTrans.position = P1Choice02.transform.position;
						SphereTrans.position = new Vector3 (LaneP1.transform.position.x, 2, SphereTrans.position.z);
					}
					//SphereTrans.position = new Vector3 (LaneP1.transform.position.x, 2, SphereTrans.position.z);
					Rigidbody SphereInstance;
					SphereInstance = Instantiate (SphereRig, SphereTrans.position, SphereTrans.rotation) as Rigidbody;
					//SphereInstance.AddForce (SphereTrans.up * speed);

					SphereInstance.gameObject.tag = "P1Sphere";
				}
			}
		}
	}

	void SpawnP1Pyramid()
	{
		if (P1Lane01 == true || P1Lane02 == true || P1Lane03 == true)
		{
			if (P1ChoiceNum < 2)
			{
				if (Input.GetKeyDown (KeyCode.D))
				{
					P1ChoiceNum++;
					if (P1ChoiceNum == 1)
					{
						PyramidTrans.position = P1Choice01.transform.position;
						PyramidTrans.position = new Vector3 (LaneP1.transform.position.x, 2, PyramidTrans.position.z);
					} else if (P1ChoiceNum == 2)
					{
						PyramidTrans.position = P1Choice02.transform.position;
						PyramidTrans.position = new Vector3 (LaneP1.transform.position.x, 2, PyramidTrans.position.z);
					}
					//PyramidTrans.position = new Vector3 (LaneP1.transform.position.x, 2, PyramidTrans.position.z);
					Rigidbody PyramidInstance;
					PyramidInstance = Instantiate (PyramidRig, PyramidTrans.position, PyramidTrans.rotation) as Rigidbody;
					//PyramidInstance.AddForce (PyramidTrans.up * speed);

					PyramidInstance.gameObject.tag = "P1Pyramid";
				}
			}
		}
	}

	//PLAYER 2 CONTROLS
	void SpawnP2Cube()
	{
		if (P2Lane01 == true || P2Lane02 == true || P2Lane03 == true)
		{
			if (P2ChoiceNum < 2)
			{
				if (Input.GetKeyDown (KeyCode.Keypad1))
				{
					P2ChoiceNum++;
					if (P2ChoiceNum == 1)
					{
						CubeTransOpp.position = P2Choice01.transform.position;
						CubeTransOpp.position = new Vector3 (LaneP2.transform.position.x, 2, CubeTransOpp.position.z);
					} else if (P2ChoiceNum == 2)
					{
						CubeTransOpp.position = P2Choice02.transform.position;
						CubeTransOpp.position = new Vector3 (LaneP2.transform.position.x, 2, CubeTransOpp.position.z);
					}
					//CubeTransOpp.position = new Vector3 (LaneP2.transform.position.x, 2, CubeTransOpp.position.z);
					Rigidbody CubeInstance;
					CubeInstance = Instantiate (CubeRig2, CubeTransOpp.position, CubeTransOpp.rotation) as Rigidbody;
					//CubeInstance.AddForce (CubeTransOpp.up * -speed);

					CubeInstance.gameObject.tag = "P2Cube";
				}
			}
		}
	}

	void SpawnP2Sphere()
	{
		//if (Lane01 == true || Lane02 == true || Lane03 == true)
		//{
			if (P2Lane01 == true || P2Lane02 == true || P2Lane03 == true)
			{
				if (P2ChoiceNum < 2)
				{
					if (Input.GetKeyDown (KeyCode.Keypad2))
					{
						P2ChoiceNum++;
						if (P2ChoiceNum == 1)
						{
							SphereTransOpp.position = P2Choice01.transform.position;
							SphereTransOpp.position = new Vector3 (LaneP2.transform.position.x, 2, SphereTransOpp.position.z);
						} else if (P2ChoiceNum == 2)
						{
							SphereTransOpp.position = P2Choice02.transform.position;
							SphereTransOpp.position = new Vector3 (LaneP2.transform.position.x, 2, SphereTransOpp.position.z);
						}
						//SphereTransOpp.position = new Vector3 (LaneP2.transform.position.x, 2, SphereTransOpp.position.z);
						Rigidbody SphereInstance;
						SphereInstance = Instantiate (SphereRig2, SphereTransOpp.position, SphereTransOpp.rotation) as Rigidbody;
						//SphereInstance.AddForce (SphereTransOpp.up * -speed);

						SphereInstance.gameObject.tag = "P2Sphere";
					}
				}
			}
		//}
	}

	void SpawnP2Pyramid()
	{
		//if (Lane01 == true || Lane02 == true || Lane03 == true)
		//{
			if (P2Lane01 == true || P2Lane02 == true || P2Lane03 == true)
			{
				if (P2ChoiceNum < 2)
				{
					if (Input.GetKeyDown (KeyCode.Keypad3))
					{
						P2ChoiceNum++;
						if (P2ChoiceNum == 1)
						{
							PyramidTransOpp.position = P2Choice01.transform.position;
							PyramidTransOpp.position = new Vector3 (LaneP2.transform.position.x, 2, PyramidTransOpp.position.z);
						} else if (P2ChoiceNum == 2)
						{
							PyramidTransOpp.position = P2Choice02.transform.position;
							PyramidTransOpp.position = new Vector3 (LaneP2.transform.position.x, 2, PyramidTransOpp.position.z);
						}
						//PyramidTransOpp.position = new Vector3 (LaneP2.transform.position.x, 2, PyramidTransOpp.position.z);
						Rigidbody PyramidInstance;
						PyramidInstance = Instantiate (PyramidRig2, PyramidTransOpp.position, PyramidTransOpp.rotation) as Rigidbody;
						//PyramidInstance.AddForce (PyramidTransOpp.up * -speed);

						PyramidInstance.gameObject.tag = "P2Pyramid";
					}
				}
			}
		//}
	}
}
