﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Instructions : MonoBehaviour {

    public CanvasRenderer CanvasRenderer;
    public Transform Pivot;
    public Transform Parent;
    public Button ContinueButton;

    const float DELTA_OFFSET = 0.015f;
    float offset = 0.0f;
    bool visible = false;
    bool canvasMoving = false;
    bool canvasRotating = false;
    Vector3 translationRate = new Vector3(0.0f, 0.0f, 5.0f);
    int timeInABit = 0;
    bool inABit = false;

    //Resetters
    Transform OriginalParent;

    // Use this for initialization
    void Start () {
        visible = true;
        ContinueButton.onClick.AddListener(ButtonPress);

        //For resetting
        OriginalParent.position = Parent.position;
        OriginalParent.rotation = Parent.rotation;
    }
	
	// Update is called once per frame
	void Update ()
    {
        //Change the texture offset
        if (visible)
        {
            offset -= DELTA_OFFSET;
            CanvasRenderer.GetMaterial().SetTextureOffset("_MainTex", new Vector2(offset, 0.0f));
        }

        //change the position/rotation of the canvas to animate it away
        if (canvasMoving)
        {
            translationRate.z += 0.1f;
            Parent.Translate(translationRate);
            //Pivot.Translate(-translationRate);
            if (Parent.position.z < -3000)
                canvasMoving = false;
        }
        if (canvasRotating)
            Parent.RotateAround(Pivot.position, Parent.up, DELTA_OFFSET * 30);
        if (Parent.rotation.eulerAngles.x > 300 && Parent.rotation.eulerAngles.x < 330)
        {  //I don't know what value to compare this to yet
            canvasRotating = false;
            visible = false;
        }

        //show the instructions
        if (inABit)
        {
            timeInABit++;
        }
        if (timeInABit > 300 && !canvasRotating && !canvasMoving)
        {
            Parent.gameObject.SetActive(false);
        }

    }

    void ButtonPress()
    {
        canvasMoving = true;
        canvasRotating = true;
        inABit = true;
    }
    
    public void InstructionsReset()
    {
        offset = 0.0f;
        visible = false;
        canvasMoving = false;
        canvasRotating = false;
        timeInABit = 0;
        inABit = false;

        Parent.position = OriginalParent.position;
        Parent.rotation = OriginalParent.rotation;
    }
}
