﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Menu : MonoBehaviour {

    public CanvasRenderer theCanvasRenderer;
    public Transform Pivot;
    public Transform Parent;
    public Button PlayButton;
    public Button InstructionsButton;
    public GameObject InstructionPage;

    //local consts/variables
    const float DELTA_OFFSET = 0.02f;
    float offset = 0.0f;
    bool visible = false;
    bool canvasMoving = false;
    bool canvasRotating = false;
    Vector3 translationRate = new Vector3(0.0f, 1.0f, 0.0f);
    int timeInABit = 0;
    bool inABit = false;
    bool showInstrucitons = true;

    //Resetters
    Transform OriginalParent;


	// Use this for initialization
	void Start () {
        //CanvasRenderer = GetComponent<CanvasRenderer>();
        visible = true;
        InstructionPage.SetActive(false);
        PlayButton.onClick.AddListener(PlayPress);
        InstructionsButton.onClick.AddListener(InstructionsPress);

        //To Reset
        OriginalParent.position = Parent.position;
        OriginalParent.rotation = Parent.rotation;
	}
	
	// Update is called once per frame
	void Update () {
        //Change the texture offset
        if (visible) {
            offset += DELTA_OFFSET;
            theCanvasRenderer.GetMaterial().SetTextureOffset("_MainTex", new Vector2(offset, 0.0f));
        }

        //change the position/rotation of the canvas to animate it away
        if(canvasMoving)
        {
            Parent.Translate(translationRate);
            //Pivot.Translate(translationRate);
            if (Parent.position.z < -300)
            {
                canvasMoving = false;
                visible = false;
            }
            else
            {
                canvasMoving = true;
                visible = true;
            }
        }
        if (canvasRotating)
            Parent.RotateAround(Pivot.position, -Parent.forward, DELTA_OFFSET * 20);
        Debug.Log(Parent.rotation.eulerAngles);
        if (Parent.rotation.eulerAngles.z < 300 && Parent.rotation.eulerAngles.z < 330)
        {
            canvasRotating = false;
        }

        //show the instructions
        if (inABit)
        {
            timeInABit++;
        }
        if(timeInABit > 120 && showInstrucitons)
        {
            InstructionPage.SetActive(true);
        }
        if(!canvasRotating && !canvasMoving && timeInABit > 300)
        {
            Parent.gameObject.SetActive(false);
        }
	}

    void PlayPress()
    {
        canvasMoving = true;
        canvasRotating = true;
        showInstrucitons = false;
        inABit = true;
    }

    void InstructionsPress()
    {
        canvasMoving = true;
        canvasRotating = true;
        inABit = true;
    }

    public void MenuReset()
    {
        offset = 0.0f;
        visible = true;
        canvasMoving = false;
        canvasRotating = false;
        timeInABit = 0;
        inABit = false;

        InstructionPage.SetActive(true);
        InstructionPage.GetComponent<Instructions>().InstructionsReset();
        InstructionPage.SetActive(false);
        Parent.gameObject.SetActive(true);
        Parent.position = OriginalParent.position;
        Parent.rotation = OriginalParent.rotation;
    }
}
