﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class ScoreBoard : MonoBehaviour {
	public Winner _Winner;
	//Scores
	private float WinningScore = 5.0f;
	public float Team1Score = 0.0f;
	public float Team2Score = 0.0f;

	private float Team1Ratio;
	private float Team2Ratio;

	//Image score based things for the teams
	public Image Team1;
	public Image Team2;

	// Use this for initialization
	void Start () {
		UpdateScoreBar ();
	}

	//Updates the score board
	public void UpdateScoreBar(){
		//Ratio change
		Team1Ratio = Team1Score / WinningScore;
		Team2Ratio = Team2Score / WinningScore;

		//Scaleing on ratio
		Team1.rectTransform.localScale = new Vector3 (Team1Ratio, 1, 1);
		Team2.rectTransform.localScale = new Vector3 (Team2Ratio, 1, 1);
	}

	//Gaining Score and losing score
	public void T1Scored (){
		//When team 1 scores
		Team1Score++;
		Team2Score--;

		//If either team score is bellow zero
		if (Team2Score < 0.0f){
			Team2Score = 0.0f;
		}

		if (Team1Score >= 5.0f){
			Team1Score = 5.0f;
			_Winner.Player1Wins ();
		}

		UpdateScoreBar ();
	}

	public void T2Scored (){
		//When team 2 scores
		Team2Score++;
		Team1Score--;

		//If either team score is bellow zero
		if (Team1Score < 0.0f){
			Team1Score = 0.0f;
		}

		if (Team2Score >= 5.0f){
			Team2Score = 5.0f;
			_Winner.Player2Wins ();
		}

		UpdateScoreBar ();
	}
}
